import 'reflect-metadata';
import { Injector } from '../core/injector';
import { RouterMetadata } from '../metadata/server/router';
import { Logger } from '../services/logger';
import { TransactionService } from '../services/transaction.service';
import { RouterService } from '../services/router.service';
import './extend-request';
export declare class RouterReflector {
    private injector;
    private logger;
    private routerMeta;
    private _router;
    private transactionService;
    constructor(injector: Injector, logger: Logger, routerMeta: RouterMetadata, _router: RouterService, transactionService: TransactionService);
    readonly router: RouterService;
    reflectRoutes(controllers?: any[]): void;
    private controllers;
    reflectControllerRoutes(controllerFn: any): void;
    private reflectRouteMeta(controllerProto);
    private addRoute(controller, routeFnName, controllerMeta, routeMeta);
    private resolvePolicies(descriptors);
    private isPolicyCtor(desc);
    private isPolicyT(desc);
    unfinishedRoutes: number;
    requestIndex: number;
    private createFullRouterFn(policies, boundRoute, transactionName, meta);
    private createPolicyResultsFn(policies, allResults);
}
